#!/bin/bash

# updated by WIPAT 2554-07-23
# usage: sh check-ldap.sh 'username' 'password'
# output true = correct, false = incorrect

LDAP_HOST="ldap://front.psu.ac.th"
LDAP_BASE="dc=cc,dc=psu"

USER=$1
MYPASS=$2
if [ -z "$2" ] ; then
  echo "false"
  exit 2
fi
BASEPASS=$(ldapsearch -H ${LDAP_HOST} -x -b ${LDAP_BASE} uid=${USER}|grep -i userPassword::|awk '{print $2}')
if [ -z "${BASEPASS}" ] ; then
  echo "false"
  exit 1
fi
DECODEPASS=$(echo "${BASEPASS}"|base64 -d)
TYPE=$(echo "${DECODEPASS}"|cut -d '{' -f 2|cut -d '}' -f 1|tr [:upper:] [:lower:])
if [ "${TYPE}" = "crypt" ] ; then 
  SALT=$(echo "${DECODEPASS}"|cut -d '}' -f 2|cut -c 1-2)
  if [ "${SALT}" = '$1' ] ; then
    SALT=$(echo "${DECODEPASS}"|cut -d '}' -f 2|cut -d'$' -f 3)
    METHOD="md5"
  else
    METHOD="des"
  fi 
  LDAPPASS=$(echo "${DECODEPASS}"|cut -d '}' -f 2-)
  GENPASS=$(mkpasswd -m $METHOD -S ${SALT} ${MYPASS})
  if [ "${LDAPPASS}" = "${GENPASS}" ] ; then
    echo " true "
    exit 0
  fi
fi
echo "false"
exit 3
